#include <ESP8266WiFi.h>
#include <time.h>
#include <Adafruit_NeoPixel.h>


// Which pin on the Arduino is connected to the NeoPixels?
#define PIN  2 // DATA PIN

// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS 64 // Popular NeoPixel 8X8
char time_value[25];

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

#define DELAYVAL 800 // Time (in milliseconds) to pause between pixels
#define WHITE pixels.Color(127,127,127)
#define RED pixels.Color(127,0,0)
#define GREEN pixels.Color(0,127,0)
#define BLUE pixels.Color(0,0,127)
#define OFF pixels.Color(0,0,0)
#define PURPLE pixels.Color(127, 0, 127) 
#define CYAN pixels.Color(0,127,127)
#define YELLOW pixels.Color(127,127,0)

long t1, t2 ;
//int secPixel=7;
int minPixel=0;
int Chour,Cmin;
int Csec = 7;
int AmPm = 0;
int Hourfive = 0;
int Hourthree = 0;
int Hourtwo = 0;
int Houronef = 0;
int Hourones = 0;

int Minfive = 0;
int Minthree = 0;
int Mintwo = 0;
int Minonef = 0;
int Minones = 0;
int DayColor;
int AMCOLOR = RED;
int PMCOLOR = BLUE;

void setup() {
  Serial.begin(9600);                  
  Serial.print("Hello World");
  pixels.begin(); // INITIALIZE NeoPixel matrix object (REQUIRED)
  WiFi.begin("Enter ur wifi Username","enter Wifi password");
  
  configTime(0 * 3600, 0, "in.pool.ntp.org", "time.nist.gov");
  setenv("TZ", "IST-5:30",1);
   drawOneL(WHITE);
  drawOneU(WHITE);
  drawTwo(WHITE);
  drawThree(WHITE);
  drawFive(WHITE);
  for(int i=3; i<6; i++) { // For each pixel in strip...

        pixels.setPixelColor(i+16, YELLOW); 
        pixels.setPixelColor(i+24, YELLOW);      
        pixels.setPixelColor(i+32, YELLOW); 
        pixels.setPixelColor(i+40, YELLOW); 
        pixels.show();
  }  

  while ( WiFi.status() != WL_CONNECTED ) {  
     pixels.setPixelColor(28, BLUE);    
     pixels.setPixelColor(36, BLUE);
      pixels.show();
    delay(250);
     pixels.setPixelColor(28, RED);
     pixels.setPixelColor(36, RED);
     pixels.show();
    delay(250);
  }   
t1=millis();
pixels.clear(); // Set all pixel colors to 'off'
}

void loop() {
    t2 = millis();
    if ( t2 >= t1 + 1000){
      if (Csec > 63 ){
        Csec = 7;
      }

      t1 = t2;  
      drawSec( DayColor, Csec);
      Csec = Csec + 8;
      }
      Serial.println(Csec);
 

   time_t now = time(nullptr);
   String time = String(ctime(&now));
   time.trim();
   String curHour = time.substring(11,13); 
   Chour = curHour.toInt();
   String curMin = time.substring(14,16); 
   Cmin = curMin.toInt();
   int oldCmin = Cmin;
     if (oldCmin != Cmin) {
      oldCmin=Cmin;
      pixels.clear();
     }
   int Bmin = Cmin%5;
   int Imin = Cmin/5;
//   pixels.clear(); // Set all pixel colors to 'off'

  if (Chour > 12){
    Chour = Chour - 12;
    DayColor = PMCOLOR;
  } else {
    DayColor = AMCOLOR;
  }
 
 switch (Chour) {
    case 12:
          Hourfive = 1;
          Hourthree = 1;
          Hourtwo = 1;
          Houronef = 1;
          Hourones = 1;
          break;
      case 11:
          Hourfive = 1;
          Hourthree = 1;
          Hourtwo = 1;
          Houronef = 1;
          Hourones = 0;
          break;
      case 10:
          Hourfive = 1;
          Hourthree = 1;
          Hourtwo = 1;
          Houronef = 0;
          Hourones = 0;
          break;
      case 9:
          Hourfive = 1;
          Hourthree = 1;
          Hourtwo = 0;
          Houronef = 1;
          Hourones = 0;
          break;
      case 8:
          Hourfive = 1;
          Hourthree = 1;
          Hourtwo = 0;
          Houronef = 0;
          Hourones = 0;
          break;
      case 7:
          Hourfive = 1;
          Hourthree = 0;
          Hourtwo = 1;
          Houronef = 0;
          Hourones = 0;
          break;
      case 6:
          Hourfive = 1;
          Hourthree = 0;
          Hourtwo = 0;
          Houronef = 1;
          Hourones = 0;
          break;
      case 5:
          Hourfive = 1;
          Hourthree = 0;
          Hourtwo = 0;
          Houronef = 0;
          Hourones = 0;
          break;
      case 4:
          Hourfive = 0;
          Hourthree = 1;
          Hourtwo = 0;
          Houronef = 1;
          Hourones = 0;
          break;
      case 3:
          Hourfive = 0;
          Hourthree = 1;
          Hourtwo = 0;
          Houronef = 0;
          Hourones = 0;
          break;
      case 2:
          Hourfive = 0;
          Hourthree = 0;
          Hourtwo = 1;
          Houronef = 0;
          Hourones = 0;
          break;
       case 1:
          Hourfive = 0;
          Hourthree = 0;
          Hourtwo = 0;
          Houronef = 1;
          Hourones = 0;
          break;
      }

switch (Imin) {
      case 12:
          Minfive = 1;
          Minthree = 1;
          Mintwo = 1;
          Minonef = 1;
          Minones = 1;
          break;
     case 11:
          Minfive = 1;
          Minthree = 1;
          Mintwo = 1;
          Minonef = 0;
          Minones = 1;
          break;
     case 10:
          Minfive = 1;
          Minthree = 1;
          Mintwo = 1;
          Minonef = 0;
          Minones = 0;
          break;
     case 9:
          Minfive = 1;
          Minthree = 1;
          Mintwo = 0;
          Minonef = 0;
          Minones = 1;
          break;
     case 8:
          Minfive = 1;
          Minthree = 0;
          Mintwo = 1;
          Minonef = 0;
          Minones = 1;
          break;
     case 7:
          Minfive = 1;
          Minthree = 0;
          Mintwo = 0;
          Minonef = 1;
          Minones = 1;
          break;
     case 6:
          Minfive = 1;
          Minthree = 0;
          Mintwo = 0;
          Minonef = 0;
          Minones = 1;
          break;
     case 5:
          Minfive = 0;
          Minthree = 1;
          Mintwo = 1;
          Minonef = 0;
          Minones = 0;
          break;
     case 4:
          Minfive = 0;
          Minthree = 0;
          Mintwo = 1;
          Minonef = 1;
          Minones = 1;
          break;
     case 3:
          Minfive = 0;
          Minthree = 0;
          Mintwo = 1;
          Minonef = 0;
          Minones = 1;
          break;
     case 2:
          Minfive = 0;
          Minthree = 0;
          Mintwo = 0;
          Minonef = 1;
          Minones = 1;
          break;
     case 1:
          Minfive = 0;
          Minthree = 0;
          Mintwo = 0;
          Minonef = 0;
          Minones = 1;
          break;
     case 0:
          Minfive = 0;
          Minthree = 0;
          Mintwo = 0;
          Minonef = 0;
          Minones = 0;
          break;  
    }

      
    if ((Houronef == 1) && (Minonef == 1)){
        drawOneL(GREEN);// 1X1 LOWER BOX        
    }
    else if ((Houronef == 1) && (Minonef == 0)){
         drawOneL(YELLOW);// 1X1 LOWER BOX
    }
    else if ((Houronef == 0) && (Minonef == 1)){
         drawOneL(CYAN);;// 1X1 LOWER BOX
    }
    else if ((Houronef == 0) && (Minonef == 0)){
         drawOneL(OFF);// 1X1 LOWER BOX         
    }     


    if ((Hourones == 1) && (Minones == 1)){
         drawOneU(GREEN);// 1X1 UPPER BOX
    }
    else if ((Hourones == 1) && (Minones == 0)){
         drawOneU(YELLOW);// 1X1 UPPER BOX
    }
    else if ((Hourones == 0) && (Minones == 1)){
         drawOneU(CYAN);// 1X1 UPPER BOX
    }
    else if ((Hourones == 0) && (Minones == 0)){
         drawOneU(OFF);// 1X1 UPPER BOX
    }

    if ((Hourtwo == 1) && (Mintwo == 1)){
         drawTwo(GREEN);// 2X2 BOX
    }
    else if ((Hourtwo == 1) && (Mintwo == 0)){
         drawTwo(YELLOW);// 2X2 BOX
    }
    else if ((Hourtwo == 0) && (Mintwo == 1)){
         drawTwo(CYAN);// 2X2 BOX
    }
    else if ((Hourtwo == 0) && (Mintwo == 0)){
         drawTwo(OFF);// 2X2 BOX
    }

    if ((Hourthree == 1) && (Minthree == 1)){ 
         drawThree(GREEN);// 3X3 BOX
    }
    else if ((Hourthree == 1) && (Minthree == 0)){ 
         drawThree(YELLOW);// 3X3 BOX
    }
    else if ((Hourthree == 0) && (Minthree == 1)){
         drawThree(CYAN);// 3X3 BOX
    }
    else if ((Hourthree == 0) && (Minthree == 0)){ 
         drawThree(OFF);// 3X3 BOX
    }
   

    if ((Hourfive == 1) && (Minfive == 1)){
         drawFive(GREEN);// LARGE BOX 5X5
    }
    else if ((Hourfive == 1) && (Minfive == 0)){
         drawFive(YELLOW);// LARGE BOX 5X5
    }
    else if ((Hourfive == 0) && (Minfive == 1)){
         drawFive(CYAN);// LARGE BOX 5X5
    }
    else if ((Hourfive == 0) && (Minfive == 0)){
         drawFive(OFF);// LARGE BOX 5X5
    }
    drawMin(Bmin);
    delay(5000);
}
// loop ends here

void drawFive(uint32_t color) {
  for(int i=26; i<31; i++) { // For each pixel in strip...
    pixels.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    pixels.setPixelColor(i+8, color);  
    pixels.setPixelColor(i+16, color); 
    pixels.setPixelColor(i+24, color);  
    pixels.setPixelColor(i+32, color); 
    pixels.show();     
  }  
}

void drawThree(uint32_t color) {
  for(int i=2; i<5; i++) { // For each pixel in strip...
    pixels.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    pixels.setPixelColor(i+8, color);  
    pixels.setPixelColor(i+16, color); 
    pixels.show();
  }  
}
void drawTwo(uint32_t color) {
  for(int i=5; i<7; i++) { // For each pixel in strip...
    pixels.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    pixels.setPixelColor(i+8, color);  
    pixels.show();
  }  
}
void drawOneU(uint32_t color) {
    pixels.setPixelColor(22, color);         //  Set pixel's color (in RAM)
    pixels.show();
}
void drawOneL(uint32_t color) {
    pixels.setPixelColor(21, color);         //  Set pixel's color (in RAM)
    pixels.show();
}
void drawSec(uint32_t color, uint16_t indx) {
    if (indx == 7) {
      pixels.setPixelColor(63, OFF);
      pixels.setPixelColor(indx, color);         //  Set pixel's color (in RAM)
      pixels.show(); 
    } 
    if (indx > 7) {
      pixels.setPixelColor((indx-8), OFF);
      pixels.setPixelColor(indx, color);         //  Set pixel's color (in RAM)
      pixels.show();
    }  
    Serial.println("indx");
    Serial.println(indx);
}

void drawMin(int Omin) {
  switch (Omin) {
     case 1:
       for(int i=0; i<2; i++) { // For each pixel in strip...
        pixels.setPixelColor(i, PURPLE);         //  Set pixel's color (in RAM)
        pixels.setPixelColor(i+8, PURPLE);
        pixels.show();         
    }
    break;
    case 2:
      for(int i=0; i<2; i++) { 
        pixels.setPixelColor(i, PURPLE);         //  Set pixel's color (in RAM)
        pixels.setPixelColor(i+8, PURPLE);  
        pixels.setPixelColor(i+16, PURPLE); 
        pixels.setPixelColor(i+24, PURPLE);
        pixels.show();         
      }
      break;
    case 3:  
      for(int i=0; i<2; i++) { 
        pixels.setPixelColor(i, PURPLE);         //  Set pixel's color (in RAM)
        pixels.setPixelColor(i+8, PURPLE);  
        pixels.setPixelColor(i+16, PURPLE); 
        pixels.setPixelColor(i+24, PURPLE);      
        pixels.setPixelColor(i+32, PURPLE); 
        pixels.setPixelColor(i+40, PURPLE); 
        pixels.show();
      }
      break;
    case 4:  
      for(int i=0; i<2; i++) { 
        pixels.setPixelColor(i, PURPLE);         //  Set pixel's color (in RAM)
        pixels.setPixelColor(i+8, PURPLE);  
        pixels.setPixelColor(i+16, PURPLE); 
        pixels.setPixelColor(i+24, PURPLE);      
        pixels.setPixelColor(i+32, PURPLE); 
        pixels.setPixelColor(i+40, PURPLE); 
        pixels.setPixelColor(i+48, PURPLE); 
        pixels.setPixelColor(i+56, PURPLE); 
        pixels.show(); 
      }  
      break; 
   case 0:  
      for(int i=0; i<2; i++) { 
        pixels.setPixelColor(i, OFF);         //  Set pixel's color (in RAM)
        pixels.setPixelColor(i+8, OFF);  
        pixels.setPixelColor(i+16, OFF); 
        pixels.setPixelColor(i+24, OFF);      
        pixels.setPixelColor(i+32, OFF); 
        pixels.setPixelColor(i+40, OFF); 
        pixels.setPixelColor(i+48, OFF); 
        pixels.setPixelColor(i+56, OFF); 
        pixels.show(); 
      }  
      break; 

      
    }  
}
